Bug 2257770 - Review Request: breakid - Symmetry detecting and breaking library
Summary: Review Request: breakid - Symmetry detecting and breaking library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Kai A. Hiller
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/meelgroup/breakid
Whiteboard:
Depends On: 2260799
Blocks:
TreeView+ depends on / blocked
 
Reported: 2024-01-10 20:25 UTC by Jerry James
Modified: 2024-02-01 01:25 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2024-02-01 01:25:27 UTC
Type: ---
Embargoed:
V02460: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 6880265 to 6969144 (1.84 KB, patch)
2024-01-29 00:46 UTC, Fedora Review Service
no flags Details | Diff

Description Jerry James 2024-01-10 20:25:52 UTC
Spec URL: https://jjames.fedorapeople.org/breakid/breakid.spec
SRPM URL: https://jjames.fedorapeople.org/breakid/breakid-1.0.0-1.20230801git6a14320.fc40.src.rpm
Fedora Account System Username: jjames
Description: BreakID is a symmetry detecting and breaking library for SAT solvers.  It is based on Jo Devriendt's BreakID code.  It has been re-licensed by the original author to be MIT.  All modifications by Mate Soos.

This package is needed to update the cryptominisat package to its latest version.

Comment 1 Fedora Review Service 2024-01-10 20:34:27 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6880265
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2257770-breakid/fedora-rawhide-x86_64/06880265-breakid/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 Kai A. Hiller 2024-01-20 13:42:50 UTC
I looked at the package, and it is mostly fine, with the biggest issue being
licensing. There are some files that are used in the build, but do not have any
licensing information, namely:

- breakidConfig.cmake.in
- cmake_uninstall.cmake.in
- breakid_c.cpp
- breakid_c.h

You should try to talk with upstream to add the missing licensing information.
If that is not successful, maybe working around those files is possible.

Under the assumption the above files are MIT-licensed, I think the License tag
should become MIT AND BSL-1.0. The BSL-1.0 in there comes from
GetGitRevisionDescription.cmake(.in). To keep the License tag simple and be more
sure it’s correct, I‘d suggest removing files under different licenses that are
not actually used in the build:

rm -rf scripts
rm src/Makefile
rm cmake/{AddGTestSuite,AddSTPGTest,CheckFloatPrecision,Findcargo,FindM4RI,\
FindPerftools,FindPkgMacros,Findrustc,Findrustdoc,FindSqlite3,FindTBB,\
FindValgrind,Rust}.cmake

Then here are some suggestions I find sensible. They are optional, though, and
you may choose to ignore them:

- Spell out the patch file name in the spec file, because the %{name} macro
  confuses rpmlint.
- Disable setting of the optimization level flag (-O2) in CMakeList.txt to use
  Fedora’s default instead.
- Fix setting the installation directory upstream instead of downstream in the
  spec file.
- Communicate with upstream and suggest cleaning up the many unnecessary files.

Comment 3 Jerry James 2024-01-24 18:33:53 UTC
Thank you for the review, Kai!

(In reply to Kai A. Hiller from comment #2)
> I looked at the package, and it is mostly fine, with the biggest issue being
> licensing. There are some files that are used in the build, but do not have
> any
> licensing information, namely:
> 
> - breakidConfig.cmake.in
> - cmake_uninstall.cmake.in
> - breakid_c.cpp
> - breakid_c.h
> 
> You should try to talk with upstream to add the missing licensing
> information.
> If that is not successful, maybe working around those files is possible.

Okay, I have requested that upstream add the licensing information.

> Under the assumption the above files are MIT-licensed, I think the License
> tag
> should become MIT AND BSL-1.0. The BSL-1.0 in there comes from
> GetGitRevisionDescription.cmake(.in). To keep the License tag simple and be
> more
> sure it’s correct, I‘d suggest removing files under different licenses that
> are
> not actually used in the build:
> 
> rm -rf scripts
> rm src/Makefile
> rm cmake/{AddGTestSuite,AddSTPGTest,CheckFloatPrecision,Findcargo,FindM4RI,\
> FindPerftools,FindPkgMacros,Findrustc,Findrustdoc,FindSqlite3,FindTBB,\
> FindValgrind,Rust}.cmake

None of these files are shipped in the binary RPMs.  According to https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_license_field:

    "The License: field refers to the licenses of the contents of the *binary* rpm."

So I don't think removing files or adding BSL-1.0 to the License field is necessary.

> Then here are some suggestions I find sensible. They are optional, though,
> and
> you may choose to ignore them:
> 
> - Spell out the patch file name in the spec file, because the %{name} macro
>   confuses rpmlint.

That is an rpmlint bug: https://github.com/rpm-software-management/rpmlint/issues/1074.  Hopefully rpmlint upstream will fix it at some point.

> - Disable setting of the optimization level flag (-O2) in CMakeList.txt to
> use
>   Fedora’s default instead.

Okay, done.  Things were getting complicated, so this is now a patch instead of a sed invocation.

> - Fix setting the installation directory upstream instead of downstream in
> the
>   spec file.

Okay, I asked upstream to address this issue.

> - Communicate with upstream and suggest cleaning up the many unnecessary
> files.

Yes, I think a lot of those came from cryptominisat.  I think they just copied the cryptominisat cmake directory and then tweaked a few things.  I'll suggest that to upstream.

All of the upstream requests are here: https://github.com/meelgroup/breakid/issues/1.  The spec file and SRPM have been updated, at the same URLs as above.

Comment 4 Jerry James 2024-01-29 00:43:36 UTC
Upstream has made all of the requested changes and tagged a release.  However, upstream also added a command line interface which has a new dependency, so this review now depends on the argparse review (bug 2260799).

New URLs:
Spec URL: https://jjames.fedorapeople.org/breakid/breakid.spec
SRPM URL: https://jjames.fedorapeople.org/breakid/breakid-3.1.2-1.fc40.src.rpm

Comment 5 Fedora Review Service 2024-01-29 00:46:07 UTC
Created attachment 2011313 [details]
The .spec file difference from Copr build 6880265 to 6969144

Comment 6 Fedora Review Service 2024-01-29 00:46:10 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6969144
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2257770-breakid/fedora-rawhide-x86_64/06969144-breakid/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 7 Jerry James 2024-01-29 19:37:22 UTC
The argparse review is complete and the package has been built in Rawhide, with F38 and F39 updates on the way.

Comment 8 Kai A. Hiller 2024-01-31 17:28:42 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Great work, especially caring to work with upstream! Makes me happy to see
formal tools maintained in Fedora.

Looks good to me :)


===== MUST items =====

C/C++:
[x]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[x]: Package does not contain kernel modules.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "GNU Lesser General
     Public License, Version 2.1", "*No copyright* Public domain", "Boost
     Software License 1.0", "GNU General Public License, Version 2". 14
     files have unknown license. Detailed output of licensecheck in
     /home/kai/review/2257770-breakid/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 2029 bytes in 1 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: breakid-3.1.2-1.fc40.x86_64.rpm
          breakid-devel-3.1.2-1.fc40.x86_64.rpm
          breakid-debuginfo-3.1.2-1.fc40.x86_64.rpm
          breakid-debugsource-3.1.2-1.fc40.x86_64.rpm
          breakid-3.1.2-1.fc40.src.rpm
====================================================================== rpmlint session starts ======================================================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp3ix5609_')]
checks: 32, packages: 5

breakid.x86_64: W: no-manual-page-for-binary breakid
breakid-devel.x86_64: W: no-documentation
================================ 5 packages and 0 specfiles checked; 0 errors, 2 warnings, 39 filtered, 0 badness; has taken 0.6 s =================================




Rpmlint (debuginfo)
-------------------
Checking: breakid-debuginfo-3.1.2-1.fc40.x86_64.rpm
====================================================================== rpmlint session starts ======================================================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpy_elw0lc')]
checks: 32, packages: 1

================================ 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 12 filtered, 0 badness; has taken 0.2 s =================================





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 4

breakid.x86_64: W: no-manual-page-for-binary breakid
breakid-devel.x86_64: W: no-documentation
 4 packages and 0 specfiles checked; 0 errors, 2 warnings, 36 filtered, 0 badness; has taken 0.7 s 



Source checksums
----------------
https://github.com/meelgroup/breakid/archive/3.1.2/breakid-3.1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 5cb64939f451f6b3dae24b730acd496b9205358b34cfb75071e3313a248c1fa2
  CHECKSUM(SHA256) upstream package : 5cb64939f451f6b3dae24b730acd496b9205358b34cfb75071e3313a248c1fa2


Requires
--------
breakid (rpmlib, GLIBC filtered):
    libbliss.so.2()(64bit)
    libbreakid.so.3.1()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

breakid-devel (rpmlib, GLIBC filtered):
    bliss-devel(x86-64)
    breakid(x86-64)
    cmake-filesystem(x86-64)
    libbreakid.so.3.1()(64bit)

breakid-debuginfo (rpmlib, GLIBC filtered):

breakid-debugsource (rpmlib, GLIBC filtered):



Provides
--------
breakid:
    breakid
    breakid(x86-64)
    libbreakid.so.3.1()(64bit)

breakid-devel:
    breakid-devel
    breakid-devel(x86-64)
    cmake(breakid)

breakid-debuginfo:
    breakid-debuginfo
    breakid-debuginfo(x86-64)
    debuginfo(build-id)
    libbreakid.so.3.1-3.1.2-1.fc40.x86_64.debug()(64bit)

breakid-debugsource:
    breakid-debugsource
    breakid-debugsource(x86-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2257770 -L local_repo
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, C/C++, Generic
Disabled plugins: Haskell, Perl, Python, Java, Ocaml, PHP, SugarActivity, R, fonts
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 9 Jerry James 2024-01-31 22:39:11 UTC
Thank you for the review, Kai!  This package will be used in the next build of the cryptominisat package, which seems to be making upstream very happy. :-)

I forgot about the lack of a man page.  It looks like help2man generates a readable, if somewhat ugly, man page.  I'll add that when I import.

Comment 10 Fedora Admin user for bugzilla script actions 2024-01-31 22:42:26 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/breakid

Comment 11 Fedora Update System 2024-02-01 01:22:16 UTC
FEDORA-2024-bd6e13f947 has been submitted as an update to Fedora 40. https://bodhi.fedoraproject.org/updates/FEDORA-2024-bd6e13f947

Comment 12 Fedora Update System 2024-02-01 01:25:27 UTC
FEDORA-2024-bd6e13f947 has been pushed to the Fedora 40 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.